/*
 *  TOPPERS/DeviceManager
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      DeviceManager
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *            Graduate School of Information Science, Nagoya Univ., JAPAN  
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 *
 */

#include "stdafx.h"
#include <algorithm>

using namespace std;

/*
 * \brief SharedMem̃RXgN^
 * \param[in] size L̈̃TCYioCgj
 * \param[in] name L̖O
 */
SharedMem::SharedMem(unsigned long size, BSTR name)
	: count(0),hMemory(0),size(size),range(0,0),lock(1)
{
	bstr = name;
}

/*
 * \brief SharedMem̃RXgN^
 * \param[in] address L̈̊JnAhX
 * \param[in] size    L̈̃TCYioCgj
 */
SharedMem::SharedMem(unsigned long address, unsigned long size)
	: count(0),hMemory(0),size(size),range(address,size),lock(1)
{
	wchar_t tmp_smem[256];
	::wsprintf(tmp_smem, L"TOPPERS/DeviceManager:shared(0x%08X-0x%08X)", address, address+size-1);
	bstr = static_cast<LPCOLESTR>(tmp_smem);
}

/*
 * \brief SharedMem̃RXgN^
 * \param[in] address L̈̊JnAhX
 * \param[in] size    L̈̃TCYioCgj
 * \param[in] name    L̖O
 */
SharedMem::SharedMem(unsigned long address, unsigned long size, BSTR name)
	: count(0),hMemory(0),size(size),range(address,size),lock(1)
{
	bstr = name;
}

/*
 * \brief LIuWFNg쐬
 * \retval true  
 * \retval false s
 * ̃t@C}bsOIuWFNgꍇfalseԂ
 */
bool SharedMem::CreateMem(void)
{
	LPCTSTR name = static_cast<LPCTSTR>(OLE2T(bstr));
	hMemory = ::CreateFileMapping((HANDLE)-1, NULL, PAGE_READWRITE, 0, size, name);
	/* mۂɎsꍇ */
	if(hMemory == 0){
		return false;
	}
	/* łɓ̃t@C}bsOIuWFNgꍇ */
	if(::GetLastError() == ERROR_ALREADY_EXISTS){
		::CloseHandle(hMemory);
		return false;
	}
	/* WindowsǗĂAhXɃ}bsO */
	data = (char *)::MapViewOfFile(hMemory, FILE_MAP_ALL_ACCESS, 0, 0, 0);
	::InterlockedIncrement(&count);
	return true;
}

/*
 * \brief LIuWFNg쐬i\tgEFAV~[^̗vj
 * \param[in] kernel voCKernelIuWFNg
 * \retval    true   
 * \retval    false  s
 * ̃t@C}bsOIuWFNgꍇfalseԂ
 */
bool SharedMem::CreateMem(CKernel *kernel)
{
	if(CreateMem()){
		KerRefList.push_back(kernel);
		return true;
	}else{
		return false;
	}
}

/*
 * \brief LIuWFNg쐬in[hEFAV~[^̗vj
 * \param[in] device voCDeviceIuWFNg
 * \retval    true   
 * \retval    false  s
 * ̃t@C}bsOIuWFNgꍇfalseԂ
 */
bool SharedMem::CreateMem(CDevice *device)
{
	if(CreateMem()){
		DevRefList.push_back(device);
		return true;
	}else{
		return false;
	}
}

/*
 * \brief LIuWFNg폜
 */
inline void SharedMem::ReleaseMem(void)
{
	::CloseHandle(hMemory); //t@C}bsOIuWF̉
}

/*
 * \brief L̖OƗ^ꂽOv邩mF
 * \param[in] name  r閼O
 * \retval    true  Ovꍇ
 * \retval    false OقȂꍇ
 */
bool SharedMem::NameIsEqual(BSTR name)
{
	CComBSTR bstr2(name);
	return (bstr == bstr2);
}

/*
 * \brief \tgEFAV~[^QƃXgɓo^
 * \param[in] kernel voCKernelIuWFNg
 * \retval    -1     łɃXgɓo^Ăꍇ
 * \retval    ̑ QƂĂV~[^io^̐j
 */
long SharedMem::AddKerRefList(CKernel * kernel)
{
	list<CKernel *>::iterator scope;

	scope = find(KerRefList.begin(), KerRefList.end(), kernel);
	/* łɃXgɓo^Ăꍇ */
	if(scope != KerRefList.end()){
		return -1;
	}
	/* Xgɓo^ĂȂꍇ */
	else{
		KerRefList.push_back(kernel);
		return ::InterlockedIncrement(&count);
	}
}

/*
 * \brief n[hEFAV~[^QƃXgɓo^
 * \param[in] device voCDeviceIuWFNg
 * \retval    -1     łɃXgɓo^Ăꍇ
 * \retval    ̑ QƂĂV~[^io^̐j
 */
long SharedMem::AddDevRefList(CDevice * device)
{
	list<CDevice *>::iterator scope;

	scope = find(DevRefList.begin(), DevRefList.end(), device );
	/* łɃXgɓo^Ăꍇ */
	if(scope != DevRefList.end()){
		return -1;
	}
	/* Xgɓo^ĂȂꍇ */
	else{
		DevRefList.push_back(device);
		return ::InterlockedIncrement(&count);
	}
}

/*
 * \brief \tgEFAV~[^QƃXg珜
 * \param[in] kernel voCKernelIuWFNg
 * \retval    -1     Xgɓo^ĂȂꍇ
 * \retval    ̑ QƂĂV~[^i̐j
 */
long SharedMem::RmvKerRefList(CKernel * kernel)
{
	list<CKernel *>::iterator scope;
	long ret;

	scope = find(KerRefList.begin(), KerRefList.end(), kernel);
	/* Xgɓo^ĂȂꍇ */
	if(scope == KerRefList.end()){
		return -1;
	}
	/* Xgɓo^Ăꍇ */
	else{
		KerRefList.erase(scope);
		ret = InterlockedDecrement(&count);
		if(ret == 0)
			ReleaseMem();
		return ret;
	}
}

/*
 * \brief n[hEFAV~[^QƃXg珜
 * \param[in] device voCDeviceIuWFNg
 * \retval    -1     Xgɓo^ĂȂꍇ
 * \retval    ̑ QƂĂV~[^i̐j
 */
long SharedMem::RmvDevRefList(CDevice * device)
{
	list<CDevice *>::iterator scope;
	long ret;

	scope = find(DevRefList.begin(), DevRefList.end(), device);
	/* Xgɓo^ĂȂꍇ */
	if(scope == DevRefList.end()){
		return -1;
	}
	/* Xgɓo^Ăꍇ */
	else{
		DevRefList.erase(scope);
		ret = InterlockedDecrement(&count);
		if(ret == 0)
			ReleaseMem();
		return ret;
	}
}

/*
 * \brief LQƂĂV~[^Ԃ
 * \retval LQƂĂV~[^
 */
long SharedMem::GetCount(void)
{
	return count;
}

/*
 * \brief LbN
 * \retval true  
 * \retval false s
 * TODO:gpȂƂmFł
 */
bool SharedMem::Lock(void)
{
	long cnt = ::InterlockedDecrement(&lock);
	if(cnt >= 0)
		return true;
	::InterlockedIncrement(&lock);
	return false;
}

/*
 * \brief L̃bN
 * TODO:gpȂƂmFł
 */
void SharedMem::Unlock(void)
{
	::InterlockedIncrement(&lock);
}
